#include "stdafx.h"
#include "IntKeyMouseRecorder.h"

CMouseHookInfo* CommonArea;
HANDLE Mapping;
WNDPROC wProc;
CArray<CDataOfEvent, CDataOfEvent> ArrayData;

const char* GlobMapID="Hook for mouse {D0273960-97C4-42F0-9C7B-51DF618682F2}";


extern "C" __declspec(dllimport) BOOL SetHookMouse(BOOL Activate);

//Procedura podmeni okna, sviazannogo s klassom CIntKeyMouseRecorder
LRESULT CALLBACK NewWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    CDataOfEvent data;
	
//Polychenie dannix ot xyka, dobavlenie ix v massiv
    if(uMsg==WM_COPYDATA)
    {
	   data=*(CDataOfEvent*)(*(COPYDATASTRUCT*)lParam).lpData;
   	   ArrayData.Add(data);
    }
	return CallWindowProc(wProc, hwnd, uMsg, wParam, lParam);
}


//Procedura obrabotki taiamera
void CALLBACK KeyMouseRecorderTimerProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
   POINT pt;
   CDataOfEvent data;
   char dbuffer [9];
   char tbuffer [9];

   GetCursorPos(&pt);
   strcpy(data.ApplicName, "-");
   _strdate( dbuffer );
   _strtime( tbuffer );
   sprintf(data.Date, "%s %s", dbuffer, tbuffer);
   sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);
   strcpy(data.Event, "-");
   ArrayData.Add(data);
}


//Konstryktor klassa CIntKeyMouseRecorder po ymolchaniu
CIntKeyMouseRecorder::CIntKeyMouseRecorder()
{

}

//Konstrytor klassa CIntKeyMouseRecorder, pozvoliauchij sviazat ego s oknom i tekyshim prilogeniem
CIntKeyMouseRecorder::CIntKeyMouseRecorder(HANDLE hWin, LPCTSTR CurrentDir)
{
  try
  {
	m_hWin=hWin;
    m_CurrentDir=(CString)CurrentDir;

    //Sozdanie bloka dannix, otobrajaemix v pamiat
	Mapping=CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0,
     sizeof(CommonArea), GlobMapID); 
    CommonArea=(CMouseHookInfo*)MapViewOfFile(Mapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);

    //Inicializacia dannix, otobrajaemix v pamiat
	CommonArea->FormHandle=m_hWin;
    CommonArea->Pause=TRUE;
    CommonArea->MouseLogger=TRUE;
    m_MouseLogger=TRUE;
    CommonArea->KeyLogger=TRUE;
    m_KeyLogger=TRUE;

    m_Pause=TRUE;

    m_Delay=GetOptions();
    m_IndTimer=0;

    m_CounterRecords=0;//Zapominaem poslednuy zapis iz massiva
    
    CIntKeyMouseRecorder();
  }catch(int e)
  {
    CString s;
	s.Format("    CIntKeyMouseRecorder(HANDLE hWin, LPCTSTR CurrentDir)  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  }
}


//Destryktor klassa
CIntKeyMouseRecorder::~CIntKeyMouseRecorder()
{
  try
  {
	if(!SetHookMouse(FALSE))
    return;
	if(CommonArea!=NULL)
    UnmapViewOfFile(CommonArea);
	if(Mapping!=0)
    CloseHandle(Mapping);
  }catch(int e)
  {
    CString s;
	s.Format("    CIntKeyMouseRecorder()  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  }
}


//Metod, opredeliaushij velichiny zaderjki taiamera pri opredelenii polojenia mishi
int CIntKeyMouseRecorder::GetOptions()
{
  try
  {
	//Opredelenie polojenia ini-faila, v kotorom chitaem velichiny zaderjki
	CString s=m_CurrentDir+"\\Inifile.ini";
    WIN32_FIND_DATA f;
    HANDLE fs;

	fs=FindFirstFile((LPCSTR)s, &f);
	if(fs==INVALID_HANDLE_VALUE)
	{
       return 1000;
	}
	else
	{
       FindClose(fs);
	}
	return GetPrivateProfileInt("OPTION", "Delay", 1000, s);
  }catch(int e)
  {
    CString s;
	s.Format("    GetOptions  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
    return 1000;
  }
}


//Metod, ystanavlivaushij velichiny zaderjki taimera, pri opredelenii polojenia mishi
void CIntKeyMouseRecorder::SetOptions(int delay)
{
  try
  {
	CString s=m_CurrentDir+"\\Inifile.ini";
    WIN32_FIND_DATA f;
    HANDLE fs;

	fs=FindFirstFile((LPCSTR)s, &f);
	if(fs==INVALID_HANDLE_VALUE)
	{
	    OFSTRUCT str;
		HFILE hf=OpenFile((LPCSTR)s, &str, OF_CREATE);
		if(hf==HFILE_ERROR)
        return;
		CloseHandle((HANDLE)hf);
	}
	else
	{
        FindClose(fs);
	}
    CString s1;
	s1.Format("%u", delay);
    WritePrivateProfileString("OPTION", "Delay", s1, s);
  }catch(int e)
  {
    CString s;
	s.Format("    SetOptions  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  }
}


//Metod ochistki massiva
void CIntKeyMouseRecorder::ClearArrayData()
{
  try
  {
	ArrayData.RemoveAll();
    ArrayData.FreeExtra();
  }catch(int e)
  {
    CString s;
	s.Format("    ClearArrayData  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  }
}


//Metod zapyska zapisi
BOOL CIntKeyMouseRecorder::StartRecord()
{   
  try
  {
	if(CommonArea==NULL)
    return FALSE;
	//Na vsiakij slychaj stavim payzy v TRUE
    CommonArea->Pause=TRUE;
    m_Pause=TRUE;
	//Podmeniaem procedury okna na svou
	wProc=(WNDPROC)SetWindowLong((HWND)m_hWin, GWL_WNDPROC, (LONG)&NewWndProc);
	if(wProc==NULL)
    return FALSE;
    ClearArrayData();
	//Ystanavlivaem hyk
	if(!SetHookMouse(TRUE))
    return FALSE;
	//Ystanavlivaem payzy v FALSE, process poshel
    CommonArea->Pause=FALSE;
    m_Pause=FALSE;
    SetTimerRecorder();
    return TRUE;
  }catch(int e)
  {
    CString s;
	s.Format("    StartRecord  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
	return FALSE;
  }
}


//Metod ostanovki zapisi
BOOL CIntKeyMouseRecorder::StopRecord()
{
  try
  {
	if(CommonArea==NULL)
    return FALSE;
    CommonArea->Pause=TRUE;
    m_Pause=TRUE;
	if(wProc==NULL)
    return FALSE;
	//Vozvrashaem rodnyu procedyry okna
	WNDPROC oldProc=(WNDPROC)SetWindowLong((HWND)m_hWin, GWL_WNDPROC, (LONG)wProc);
    if(oldProc==NULL)
    return FALSE;
	//Snimaem xyk
    if(!SetHookMouse(FALSE))
    return FALSE;
    CommonArea->Pause=FALSE;
    m_Pause=FALSE;
    ClearArrayData();
    KillTimerRecorder();
    return TRUE;
  }catch(int e)
  {
    CString s;
	s.Format("    StopRecord  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
	return FALSE;
  }
}


//Metod ystanovki-sniatia payzi
void CIntKeyMouseRecorder::PauseContinueRecord(BOOL pause)
{
  try
  {
    if(pause==m_Pause)
    return;		
	if(CommonArea==NULL)
    return;
    CommonArea->Pause=pause;
    m_Pause=pause;
	if(m_Pause)
    KillTimerRecorder();
	else
    SetTimerRecorder();
  }catch(int e)
  {
    CString s;
	s.Format("    PauseContinueRecord  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  }
}


//Metod zapisi v fail
BOOL CIntKeyMouseRecorder::SaveToFile()
{
  try
  {
	CString s=m_CurrentDir+"\\Logfile.log", s1;
    OFSTRUCT str;
    HFILE hf;
    CDataOfEvent data;
	DWORD nb=0;
    int count;
	BOOL pause=m_Pause;
    WIN32_FIND_DATA f;

    PauseContinueRecord(TRUE);

	if(FindFirstFile((LPCSTR)s, &f)!=INVALID_HANDLE_VALUE)
	{
       hf=OpenFile((LPCSTR)s, &str, OF_WRITE);
	   if(hf==HFILE_ERROR)
       return FALSE;
       SetFilePointer((HANDLE)hf, NULL, NULL, FILE_END);
	}
	else
	{
       m_CounterRecords=0;
	   hf=OpenFile((LPCSTR)s, &str, OF_CREATE);
	   if(hf==HFILE_ERROR)
       return FALSE;
	}

   	count=ArrayData.GetSize();
	for(int i=m_CounterRecords; i<count; i++)
	{
		data=ArrayData.GetAt(i);
        s1=data.Date;
		s1+="\n";
		WriteFile((HANDLE)hf, s1, s1.GetLength(), &nb, NULL);
		s1=data.ApplicName;
		s1="Prilojenie: "+s1+"\n";
        WriteFile((HANDLE)hf, s1, s1.GetLength(), &nb, NULL);
		s1=data.Event;
        s1="Sobitie: "+s1+"\n";
        WriteFile((HANDLE)hf, s1, s1.GetLength(), &nb, NULL);
		s1=data.Coordin;
        s1="Koordinati: "+s1+"\n";
        WriteFile((HANDLE)hf, s1, s1.GetLength(), &nb, NULL);
		s1="\n";
        WriteFile((HANDLE)hf, s1, s1.GetLength(), &nb, NULL);
	}
    CloseHandle((HANDLE)hf);
    m_CounterRecords=count;
    PauseContinueRecord(pause);
    return TRUE;
  }catch(int e)
  {
    CString s;
	s.Format("    SaveToFile  %d", e);
	MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
    return FALSE;
  }
}

//Metod, vozvrashaushij sostoianie zapisi mishi
BOOL CIntKeyMouseRecorder::GetMouseLogger()
{
    return m_MouseLogger;
}

//Metod, ystanavlivaushij sostoianie zapisi mishi
void CIntKeyMouseRecorder::SetMouseLogger(BOOL MouseLogger)
{
    if(m_MouseLogger==MouseLogger)
	return;
	m_MouseLogger=MouseLogger;
    CommonArea->MouseLogger=MouseLogger;
}

//Metod, vozvrashiaushij sostoianie zapisi klaviatyri
BOOL CIntKeyMouseRecorder::GetKeyLogger()
{
    return m_KeyLogger;
}

//Metod, ystanavlivaushij sostoianie zapisi klaviatyri
void CIntKeyMouseRecorder::SetKeyLogger(BOOL KeyLogger)
{
    if(m_KeyLogger==KeyLogger)
	return;
	m_KeyLogger=KeyLogger;
    CommonArea->KeyLogger=KeyLogger;
}

//Metod, ystanavlivaushij taijmer
void CIntKeyMouseRecorder::SetTimerRecorder()
{
    try
	{
	   m_IndTimer=SetTimer(NULL, 1, GetOptions(), (TIMERPROC)&KeyMouseRecorderTimerProc);
	}catch(int e)
	{
      CString s;
	  s.Format("    SetTimerRecorder  %d", e);
	  MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  	}
}

//Metod, snimaushij taijmer
void CIntKeyMouseRecorder::KillTimerRecorder()
{
    try
	{
	   if(m_IndTimer==0)
	   return;
	   KillTimer(NULL, m_IndTimer);
	   m_IndTimer=0;
	}catch(int e)
	{
      CString s;
	  s.Format("    KillTimerRecorder  %d", e);
	  MessageBox(0, s, "KeyMouseRecorder", MB_OK | MB_ICONERROR);
  	}
}
