// KeyMouseRecorderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "KeyMouseRecorder.h"
#include "KeyMouseRecorderDlg.h"
#include "OptionsDlg.h"
#include "resource.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



CKeyMouseRecorderDlg::CKeyMouseRecorderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyMouseRecorderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyMouseRecorderDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CKeyMouseRecorderDlg::~CKeyMouseRecorderDlg()
{
   delete m_KeyMouseRecorder;
   Shell_NotifyIcon(NIM_DELETE, &Nim);
}

void CKeyMouseRecorderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyMouseRecorderDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyMouseRecorderDlg, CDialog)
	//{{AFX_MSG_MAP(CKeyMouseRecorderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(IDR_MENU_MOUSELOGGER, OnMenuMouselogger)
	ON_COMMAND(IDR_MENU_KEYLOGGER, OnMenuKeylogger)
	ON_COMMAND(IDR_MENU_EXIT, OnMenuExit)
	ON_COMMAND(IDR_MENU_DELAY, OnMenuDelay)
	ON_COMMAND(IDR_MENU_START_RECORD, OnMenuStartRecord)
	ON_COMMAND(IDR_MENU_STOP_RECORD, OnMenuStopRecord)
	ON_COMMAND(IDR_MENU_PAUSE_RECORD, OnMenuPauseRecord)
	ON_COMMAND(IDR_MENU_CONTINUE_RECORD, OnMenuContinueRecord)
	ON_COMMAND(IDR_MENU_SAVETOFILE, OnMenuSavetofile)
    ON_MESSAGE(WM_USER+100, OnIconNotification)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//ON_MESSAGE(WM_USER+100, OnIconNotification)

/////////////////////////////////////////////////////////////////////////////
// CKeyMouseRecorderDlg message handlers

BOOL CKeyMouseRecorderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);// Set small icon
	m_Menu.LoadMenu(IDR_MENU1);

    char PatchName[255];
	GetCurrentDirectory(255, PatchName);
    
 	m_KeyMouseRecorder=new CIntKeyMouseRecorder((HANDLE)this->m_hWnd, PatchName);
    
    ZeroMemory(&Nim, sizeof(Nim));
    Nim.cbSize=sizeof(NOTIFYICONDATA);
	Nim.hWnd=AfxGetMainWnd()->GetSafeHwnd()? AfxGetMainWnd()->GetSafeHwnd() : m_hWnd;
	Nim.uID=1;
	Nim.uFlags=NIF_ICON | NIF_MESSAGE | NIF_TIP;
	Nim.hIcon=m_hIcon;
	Nim.uCallbackMessage=WM_USER+100;
    _tcscpy(Nim.szTip, "KeyMouseRecorder");
	
    Shell_NotifyIcon(NIM_ADD, &Nim);
     
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKeyMouseRecorderDlg::OnPaint() 
{
    ShowWindow(SW_HIDE);
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyMouseRecorderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CKeyMouseRecorderDlg::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::Create(IDD, pParentWnd);
    
}


LRESULT CKeyMouseRecorderDlg::OnIconNotification(WPARAM wParam, LPARAM lParam)
{
   	if(lParam==WM_RBUTTONUP)
	{
        CWnd* pTarget = AfxGetMainWnd();
	    CPoint point;
        GetCursorPos(&point);

        pTarget->SetForegroundWindow();
        ::TrackPopupMenu(m_Menu.GetSubMenu(0)->m_hMenu, 0, point.x, point.y, 0, 
          pTarget->GetSafeHwnd(), NULL);
        pTarget->PostMessage(WM_NULL, 0, 0);
	}
 	return lParam;
}


void CKeyMouseRecorderDlg::OnEditPaste() 
{
	// TODO: Add your command handler code here
	EndDialog(0);
}

void CKeyMouseRecorderDlg::OnMenuMouselogger() 
{
	// TODO: Add your command handler code here
   	if((m_Menu.GetSubMenu(0)->GetMenuState(IDR_MENU_MOUSELOGGER, MF_BYCOMMAND) & MF_CHECKED))
    m_Menu.GetSubMenu(0)->CheckMenuItem(IDR_MENU_MOUSELOGGER, MF_BYCOMMAND | MF_UNCHECKED);
	else
    m_Menu.GetSubMenu(0)->CheckMenuItem(IDR_MENU_MOUSELOGGER, MF_BYCOMMAND | MF_CHECKED);
	m_KeyMouseRecorder->SetMouseLogger((m_Menu.GetSubMenu(0)->GetMenuState(IDR_MENU_MOUSELOGGER, MF_BYCOMMAND) & MF_CHECKED));
}

void CKeyMouseRecorderDlg::OnMenuKeylogger() 
{
	// TODO: Add your command handler code here
    if((m_Menu.GetSubMenu(0)->GetMenuState(IDR_MENU_KEYLOGGER, MF_BYCOMMAND) & MF_CHECKED))
    m_Menu.GetSubMenu(0)->CheckMenuItem(IDR_MENU_KEYLOGGER, MF_BYCOMMAND | MF_UNCHECKED);
	else
    m_Menu.GetSubMenu(0)->CheckMenuItem(IDR_MENU_KEYLOGGER, MF_BYCOMMAND | MF_CHECKED);
	m_KeyMouseRecorder->SetKeyLogger((m_Menu.GetSubMenu(0)->GetMenuState(IDR_MENU_KEYLOGGER, MF_BYCOMMAND) & MF_CHECKED));
}

void CKeyMouseRecorderDlg::OnMenuExit() 
{
	// TODO: Add your command handler code here
   EndDialog(0);
	
}

void CKeyMouseRecorderDlg::OnMenuDelay() 
{
	// TODO: Add your command handler code here
	COptionsDlg dlg(this);
	dlg.m_IntKeyMouseRecorder=m_KeyMouseRecorder;
	dlg.m_Edit1=m_KeyMouseRecorder->GetOptions();
	dlg.DoModal();
}

void CKeyMouseRecorderDlg::OnMenuStartRecord() 
{
	// TODO: Add your command handler code here
    if((!m_KeyMouseRecorder->GetMouseLogger()) && (!m_KeyMouseRecorder->GetKeyLogger()))
	return;   
	if(!m_KeyMouseRecorder->StartRecord())
    return;
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_START_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_STOP_RECORD, MF_ENABLED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_PAUSE_RECORD, MF_ENABLED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_CONTINUE_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_SAVETOFILE, MF_ENABLED);
}

void CKeyMouseRecorderDlg::OnMenuStopRecord() 
{
	// TODO: Add your command handler code here
	if(!m_KeyMouseRecorder->StopRecord())
    return;
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_START_RECORD, MF_ENABLED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_STOP_RECORD, MF_GRAYED);
	m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_PAUSE_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_CONTINUE_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_SAVETOFILE, MF_GRAYED);
}

void CKeyMouseRecorderDlg::OnMenuPauseRecord() 
{
	// TODO: Add your command handler code here
    m_KeyMouseRecorder->PauseContinueRecord(TRUE);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_START_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_STOP_RECORD, MF_ENABLED);
	m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_PAUSE_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_SAVETOFILE, MF_ENABLED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_CONTINUE_RECORD, MF_ENABLED);
}

void CKeyMouseRecorderDlg::OnMenuContinueRecord() 
{
	// TODO: Add your command handler code here
    m_KeyMouseRecorder->PauseContinueRecord(FALSE);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_START_RECORD, MF_GRAYED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_STOP_RECORD, MF_ENABLED);
	m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_PAUSE_RECORD, MF_ENABLED);
    m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_CONTINUE_RECORD, MF_GRAYED);
	m_Menu.GetSubMenu(0)->EnableMenuItem(IDR_MENU_SAVETOFILE, MF_ENABLED);
}

void CKeyMouseRecorderDlg::OnMenuSavetofile() 
{
	// TODO: Add your command handler code here
	m_KeyMouseRecorder->SaveToFile();
}
